/********************************************************************************************/
/*******                                                                              *******/
/*******  HeavyMole <heavymole@touva.be>                                              *******/
/*******  Copyright (C) 2000  L. Antoine <antoinem@touva.be>                          *******/
/*******                      C. Van brussel <kickvb@touva.be>                        *******/
/*******                                                                              *******/
/*******  This program is free software; you can redistribute it and/or               *******/
/*******  modify it under the terms of the GNU General Public License                 *******/
/*******  as published by the Free Software Foundation; either version 2              *******/
/*******  of the License, or (at your option) any later version.                      *******/
/*******                                                                              *******/
/*******  This program is distributed in the hope that it will be useful,             *******/
/*******  but WITHOUT ANY WARRANTY; without even the implied warranty of              *******/
/*******  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *******/
/*******  GNU General Public License for more details.                                *******/
/*******                                                                              *******/
/*******  You should have received a copy of the GNU General Public License           *******/
/*******  along with this program; if not, write to the Free Software                 *******/
/*******  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *******/
/*******                                                                              *******/
/********************************************************************************************/

#ifndef _PROGRESSCELLRENDERER
#define _PROGRESSCELLRENDERER

#include <gtkmm.h>

class ProgressCellRenderer : public Gtk::CellRenderer
{
public:
  ProgressCellRenderer();
  virtual ~ProgressCellRenderer();

  void get_size_vfunc(Gtk::Widget& widget, const Gdk::Rectangle& cell_area, int& x_offset, int& y_offset, int& width, int& height);
  void render_vfunc(const Glib::RefPtr<Gdk::Window>& window, Gtk::Widget& widget, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, const Gdk::Rectangle& expose_area, Gtk::CellRendererState flags);

  virtual Glib::PropertyProxy_Base _property_renderable();
  Glib::PropertyProxy<int> property_progress_value();
  Glib::PropertyProxy< Glib::RefPtr<Gdk::Pixbuf> > property_progress_pixmap();

protected:
  Glib::Property<int> property_progress_value_;
  Glib::Property< Glib::RefPtr<Gdk::Pixbuf> > property_progress_pixmap_;
};

#endif // _PROGRESSCELLRENDERER
